Option Explicit
Global PortA_DCB As DCB
Global PortB_DCB As DCB
Global Temp_DCB As DCB
Global PortA_nCid As Integer
Global PortB_nCid As Integer
Global Temp_nCid As Integer
Global PortAIdent As String
Global PortBIdent As String
Global RXA_BUFFERSIZE As Integer
Global RXB_BUFFERSIZE As Integer
Global Display As Integer
Global Capture As Integer
Global FileNum As Integer
Global PortA As String
Global PortB As String

Sub PollComm ()
Dim RxA_CharCount As Integer
Dim TxA_CharCount As Integer
Dim RxB_CharCount As Integer
Dim TxB_CharCount As Integer
Dim CommError As Integer
Dim TempCOMSTAT As COMSTAT
Dim LoopCounter As Integer
Dim x As Integer
Dim LastPort As String
Dim CRLF As String
Dim Buffer As String


If RXA_BUFFERSIZE > RXB_BUFFERSIZE Then
    Buffer = String$(RXA_BUFFERSIZE, 0)
Else
    Buffer = String$(RXB_BUFFERSIZE, 0)
End If
CRLF = Chr$(13) & Chr$(10)
LastPort = "None"


  Do
    DoEvents
    '************ Read from Port A **********************
    'If EscapeCommFunction(PortA_nCid, SETXON) < 0 Then Beep  'needed when IRQ conflict (300 baud max)
    Buffer = String$(RXA_BUFFERSIZE, 0)
CommError = GetCommError(PortA_nCid, TempCOMSTAT)
If CommError Then
  TextPrint frmErrorList.txtErrorList, PortAIdent & " RX error:" & CRLF & DisplayCommError(CommError) & CRLF & DisplayCOMSTAT(TempCOMSTAT) & CRLF
  frmErrorList.Show
End If
    RxA_CharCount = ReadComm(PortA_nCid, Buffer, RXA_BUFFERSIZE)
    If RxA_CharCount < 0 Then
      CommError = GetCommError(PortA_nCid, TempCOMSTAT)
      TextPrint frmErrorList.txtErrorList, "Port A RX error:" & CRLF & DisplayCommError(CommError) & CRLF & DisplayCOMSTAT(TempCOMSTAT) & CRLF
      frmErrorList.Show
    End If
    '************ Print to screen & file **********************
    If RxA_CharCount Then
      If LastPort <> "A" Then
        If Display Then PicturePrint frmDisplay.pctDisplayArea, CRLF & PortAIdent & CRLF
        LastPort = "A"
        If Capture Then Print #FileNum, CRLF & PortAIdent
      End If
      If Display Then PicturePrint frmDisplay.pctDisplayArea, Left$(Buffer, RxA_CharCount)
      If Capture Then Print #FileNum, Left$(Buffer, RxA_CharCount);
    End If
    '************ Write to port B ***********************
    LoopCounter = 0
    Do While RxA_CharCount > 0
      TxB_CharCount = WriteComm(PortB_nCid, Buffer, RxA_CharCount)
      If TxB_CharCount < 1 Then
        CommError = GetCommError(PortB_nCid, TempCOMSTAT)
        TextPrint frmErrorList.txtErrorList, "Port B TX error:" & CRLF & DisplayCommError(CommError) & CRLF & DisplayCOMSTAT(TempCOMSTAT) & CRLF
        frmErrorList.Show
        TxB_CharCount = (-TxB_CharCount)
        Mid$(Buffer, 1) = Mid$(Buffer, TxB_CharCount + 1)
        RxA_CharCount = RxA_CharCount - TxB_CharCount
      Else
        Exit Do
      End If
      LoopCounter = LoopCounter + 1
      If LoopCounter > RXA_BUFFERSIZE Then
        MsgBox "Stuck in loop trying to write to port B. Ending"
        Close
        If PortA_nCid > 0 Then x = CloseComm(PortA_nCid)
        If PortB_nCid > 0 Then x = CloseComm(PortB_nCid)
        End
      End If

    Loop

    '************ Read from Port B **********************
    'If EscapeCommFunction(PortB_nCid, SETXON) < 0 Then Beep  'needed when IRQ conflict (300 baud max)
    Buffer = String$(RXB_BUFFERSIZE, 0)
CommError = GetCommError(PortB_nCid, TempCOMSTAT)
If CommError Then
  TextPrint frmErrorList.txtErrorList, PortBIdent & " RX error:" & CRLF & DisplayCommError(CommError) & CRLF & DisplayCOMSTAT(TempCOMSTAT) & CRLF
  frmErrorList.Show
End If
    RxB_CharCount = ReadComm(PortB_nCid, Buffer, RXB_BUFFERSIZE)
    If RxB_CharCount < 0 Then
      CommError = GetCommError(PortB_nCid, TempCOMSTAT)
      TextPrint frmErrorList.txtErrorList, "Port B RX error:" & CRLF & DisplayCommError(CommError) & CRLF & DisplayCOMSTAT(TempCOMSTAT) & CRLF
      frmErrorList.Show
      RxB_CharCount = (-RxB_CharCount)
    End If
    '************ Print to screen & file **********************
    If RxB_CharCount Then
      If LastPort <> "B" Then
        If Display Then PicturePrint frmDisplay.pctDisplayArea, CRLF & PortBIdent & CRLF
        LastPort = "B"
        If Capture Then Print #FileNum, CRLF & PortBIdent
      End If
      If Display Then PicturePrint frmDisplay.pctDisplayArea, Left$(Buffer, RxB_CharCount)
      If Capture Then Print #FileNum, Left$(Buffer, RxB_CharCount);
    End If

    '************ Write to port A ***********************
    LoopCounter = 0
    Do While RxB_CharCount > 0
      TxA_CharCount = WriteComm(PortA_nCid, Buffer, RxB_CharCount)
      If TxA_CharCount < 1 Then
        CommError = GetCommError(PortA_nCid, TempCOMSTAT)
        TextPrint frmErrorList.txtErrorList, "Port A TX error:" & CRLF & DisplayCommError(CommError) & CRLF & DisplayCOMSTAT(TempCOMSTAT) & CRLF
        frmErrorList.Show
        TxA_CharCount = (-TxA_CharCount)
        Mid$(Buffer, 1) = Mid$(Buffer, TxA_CharCount + 1)
        RxB_CharCount = RxB_CharCount - TxA_CharCount
      Else
        Exit Do
      End If
      LoopCounter = LoopCounter + 1
      If LoopCounter > RXB_BUFFERSIZE Then
        MsgBox "Stuck in loop trying to write to port B. Ending"
        Close
        If PortA_nCid > 0 Then x = CloseComm(PortA_nCid)
        If PortB_nCid > 0 Then x = CloseComm(PortB_nCid)
        End
      End If
    Loop
    '***************************************************

  Loop
End Sub

